/* WindowSwitcher.c generated by valac 0.56.16, the Vala compiler
 * generated from WindowSwitcher.vala, do not modify */

/*
 * Copyright 2021 Aral Balkan <mail@ar.al>
 * Copyright 2020 Mark Story <mark@mark-story.com>
 * Copyright 2017 Popye <sailor3101@gmail.com>
 * Copyright 2014 Tom Beckmann
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala.h"
#include <glib-object.h>
#include <glib.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <mtk/mtk.h>
#include <gdk/gdk.h>
#include <meta/window.h>
#include <meta/keybindings.h>
#include <meta/workspace.h>
#include <meta/meta-workspace-manager.h>
#include <meta/prefs.h>
#include <meta/meta-cursor-tracker.h>
#include <pango/pango.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#define GALA_WINDOW_SWITCHER_ICON_SIZE 64
#define GALA_WINDOW_SWITCHER_WRAPPER_PADDING 12
#define GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME "Inter"
#define GALA_WINDOW_SWITCHER_MIN_OFFSET 64
#define GALA_WINDOW_SWITCHER_ANIMATION_DURATION 200
#define GALA_WINDOW_SWITCHER_GESTURE_RANGE_LIMIT 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;
typedef struct _GalaWindowSwitcherPrivate GalaWindowSwitcherPrivate;

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;

#define GALA_TYPE_WINDOW_SWITCHER_ICON (gala_window_switcher_icon_get_type ())
#define GALA_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon))
#define GALA_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))
#define GALA_IS_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_IS_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_WINDOW_SWITCHER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))

typedef struct _GalaWindowSwitcherIcon GalaWindowSwitcherIcon;
typedef struct _GalaWindowSwitcherIconClass GalaWindowSwitcherIconClass;
enum  {
	GALA_WINDOW_SWITCHER_0_PROPERTY,
	GALA_WINDOW_SWITCHER_WM_PROPERTY,
	GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY,
	GALA_WINDOW_SWITCHER_OPENED_PROPERTY,
	GALA_WINDOW_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* gala_window_switcher_properties[GALA_WINDOW_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ClutterColor_free0(var) ((var == NULL) ? NULL : (var = (_vala_ClutterColor_free (var), NULL)))
typedef enum  {
	GALA_GESTURE_DIRECTION_UNKNOWN = 0,
	GALA_GESTURE_DIRECTION_UP = 1,
	GALA_GESTURE_DIRECTION_DOWN = 2,
	GALA_GESTURE_DIRECTION_LEFT = 3,
	GALA_GESTURE_DIRECTION_RIGHT = 4,
	GALA_GESTURE_DIRECTION_IN = 5,
	GALA_GESTURE_DIRECTION_OUT = 6
} GalaGestureDirection;

#define GALA_TYPE_GESTURE_DIRECTION (gala_gesture_direction_get_type ())
typedef struct _Block71Data Block71Data;
typedef void (*GalaGestureTrackerOnUpdate) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureTrackerOnEnd) (gdouble percentage, gboolean cancel_action, gint calculated_duration, gpointer user_data);
typedef void (*GalaGestureTrackerOnBegin) (gdouble percentage, gpointer user_data);

#define GALA_TYPE_WINDOW_TRACKER (gala_window_tracker_get_type ())
#define GALA_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker))
#define GALA_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))
#define GALA_IS_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_TRACKER))
#define GALA_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_TRACKER))
#define GALA_WINDOW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))

typedef struct _GalaWindowTracker GalaWindowTracker;
typedef struct _GalaWindowTrackerClass GalaWindowTrackerClass;

#define GALA_TYPE_WINDOW_MANAGER_GALA (gala_window_manager_gala_get_type ())
#define GALA_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala))
#define GALA_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))
#define GALA_IS_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_IS_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_WINDOW_MANAGER_GALA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))

typedef struct _GalaWindowManagerGala GalaWindowManagerGala;
typedef struct _GalaWindowManagerGalaClass GalaWindowManagerGalaClass;
typedef struct _Block72Data Block72Data;

struct _GalaWindowSwitcher {
	GalaCanvasActor parent_instance;
	GalaWindowSwitcherPrivate * priv;
};

struct _GalaWindowSwitcherClass {
	GalaCanvasActorClass parent_class;
};

struct _GalaWindowSwitcherPrivate {
	GalaWindowManager* _wm;
	GalaGestureTracker* _gesture_tracker;
	gboolean _opened;
	gboolean handling_gesture;
	gint modifier_mask;
	GalaModalProxy* modal_proxy;
	GalaDrawingStyleManager* style_manager;
	ClutterActor* container;
	ClutterText* caption;
	GalaShadowEffect* shadow_effect;
	GalaWindowSwitcherIcon* _current_icon;
	gfloat scaling_factor;
};

struct _Block71Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	gint last_window_index;
	GalaGestureDirection direction;
};

struct _Block72Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	GalaWindowSwitcherIcon* icon;
};

static gint GalaWindowSwitcher_private_offset;
static gpointer gala_window_switcher_parent_class = NULL;

VALA_EXTERN GType gala_window_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GType gala_window_switcher_icon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcherIcon, g_object_unref)
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm,
                                              GalaGestureTracker* gesture_tracker);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm,
                                                    GalaGestureTracker* gesture_tracker);
static void gala_window_switcher_scale (GalaWindowSwitcher* self);
VALA_EXTERN GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static void gala_window_switcher_real_get_preferred_width (ClutterActor* base,
                                                    gfloat for_height,
                                                    gfloat* min_width,
                                                    gfloat* natural_width);
static void gala_window_switcher_real_draw (GalaCanvasActor* base,
                                     cairo_t* ctx,
                                     gint width,
                                     gint height);
static void _vala_ClutterColor_free (ClutterColor* self);
VALA_EXTERN void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
VALA_EXTERN gboolean gala_window_switcher_get_opened (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                                       MetaDisplay* display,
                                                       MetaWorkspace* workspace);
static gboolean gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                                   MetaDisplay* display,
                                                   MetaWorkspace* workspace);
static void gala_window_switcher_open_switcher (GalaWindowSwitcher* self);
static void gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                       gboolean backward);
VALA_EXTERN GType gala_gesture_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gala_window_switcher_handle_gesture (GalaWindowSwitcher* self,
                                          GalaGestureDirection direction);
static Block71Data* block71_data_ref (Block71Data* _data71_);
static void block71_data_unref (void * _userdata_);
static void __lambda84_ (Block71Data* _data71_,
                  gdouble percentage);
VALA_EXTERN gfloat gala_gesture_tracker_animation_value (gfloat initial_value,
                                             gfloat target_value,
                                             gdouble percentage,
                                             gboolean rounded);
static void ___lambda84__gala_gesture_tracker_on_update (gdouble percentage,
                                                  gpointer self);
static void __lambda85_ (GalaWindowSwitcher* self,
                  gdouble percentage,
                  gboolean cancel_action,
                  gint calculated_duration);
static void gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                          guint32 time,
                                          gboolean cancel);
static void ___lambda85__gala_gesture_tracker_on_end (gdouble percentage,
                                               gboolean cancel_action,
                                               gint calculated_duration,
                                               gpointer self);
VALA_EXTERN GalaGestureTracker* gala_window_switcher_get_gesture_tracker (GalaWindowSwitcher* self);
VALA_EXTERN void gala_gesture_tracker_connect_handlers (GalaGestureTracker* self,
                                            GalaGestureTrackerOnBegin on_begin_handler,
                                            gpointer on_begin_handler_target,
                                            GDestroyNotify on_begin_handler_target_destroy_notify,
                                            GalaGestureTrackerOnUpdate on_update_handler,
                                            gpointer on_update_handler_target,
                                            GDestroyNotify on_update_handler_target_destroy_notify,
                                            GalaGestureTrackerOnEnd on_end_handler,
                                            gpointer on_end_handler_target,
                                            GDestroyNotify on_end_handler_target_destroy_notify);
static void gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                            GalaWindowSwitcherIcon* value);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_new (MetaWindow* window,
                                                       gint icon_size,
                                                       gfloat scale_factor);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_construct (GType object_type,
                                                             MetaWindow* window,
                                                             gint icon_size,
                                                             gfloat scale_factor);
static void gala_window_switcher_add_icon (GalaWindowSwitcher* self,
                                    GalaWindowSwitcherIcon* icon);
VALA_EXTERN GType gala_window_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowTracker, g_object_unref)
VALA_EXTERN GType gala_window_manager_gala_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowManagerGala, g_object_unref)
VALA_EXTERN GalaWindowTracker* gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self);
VALA_EXTERN GalaApp* gala_window_tracker_get_app_for_window (GalaWindowTracker* self,
                                                 MetaWindow* window);
static Block72Data* block72_data_ref (Block72Data* _data72_);
static void block72_data_unref (void * _userdata_);
static gboolean __lambda82_ (Block72Data* _data72_);
static GalaWindowSwitcherIcon* gala_window_switcher_get_current_icon (GalaWindowSwitcher* self);
static gboolean ___lambda82__clutter_actor_motion_event (ClutterActor* _sender,
                                                  ClutterEvent* event,
                                                  gpointer self);
static void gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                          gboolean show);
static void gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                      gboolean value);
static void gala_window_switcher_push_modal (GalaWindowSwitcher* self);
static gboolean __lambda83_ (GalaWindowSwitcher* self,
                      MetaKeyBinding* binding);
static gboolean ___lambda83__gala_keybinding_filter (MetaKeyBinding* binding,
                                              gpointer self);
VALA_EXTERN MetaWindow* gala_window_switcher_icon_get_window (GalaWindowSwitcherIcon* self);
static void gala_window_switcher_update_caption_text (GalaWindowSwitcher* self);
static void gala_window_switcher_real_key_focus_out (ClutterActor* base);
static gboolean gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                                       ClutterEvent* event);
static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base,
                                                      ClutterEvent* event);
static inline ClutterModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static void gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                                  GalaWindowManager* value);
static void gala_window_switcher_set_gesture_tracker (GalaWindowSwitcher* self,
                                               GalaGestureTracker* value);
VALA_EXTERN void gala_window_switcher_icon_set_selected (GalaWindowSwitcherIcon* self,
                                             gboolean value);
static GObject * gala_window_switcher_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static gboolean _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                           ClutterEvent* event,
                                                                                           gpointer self);
static void _clutter_content_invalidate_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self);
static void _gala_window_switcher_scale_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                        gpointer self);
static void _gala_window_switcher___lambda86_ (GalaWindowSwitcher* self);
static void __gala_window_switcher___lambda86__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void gala_window_switcher_finalize (GObject * obj);
static GType gala_window_switcher_get_type_once (void);
static void _vala_gala_window_switcher_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_switcher_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_window_switcher_get_instance_private (GalaWindowSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowSwitcher_private_offset);
}

GalaWindowSwitcher*
gala_window_switcher_construct (GType object_type,
                                GalaWindowManager* wm,
                                GalaGestureTracker* gesture_tracker)
{
	GalaWindowSwitcher * self = NULL;
#line 53 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 53 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (gesture_tracker != NULL, NULL);
#line 54 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) g_object_new (object_type, "wm", wm, "gesture-tracker", gesture_tracker, NULL);
#line 53 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self;
#line 352 "WindowSwitcher.c"
}

GalaWindowSwitcher*
gala_window_switcher_new (GalaWindowManager* wm,
                          GalaGestureTracker* gesture_tracker)
{
#line 53 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return gala_window_switcher_construct (GALA_TYPE_WINDOW_SWITCHER, wm, gesture_tracker);
#line 361 "WindowSwitcher.c"
}

static void
gala_window_switcher_scale (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	GalaShadowEffect* _tmp4_;
	gint margin = 0;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterText* _tmp9_;
	ClutterText* _tmp10_;
	ClutterText* _tmp11_;
#line 106 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 107 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 107 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->_wm;
#line 107 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 107 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = meta_display_get_monitor_scale (_tmp1_, meta_display_get_current_monitor (_tmp3_));
#line 109 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->shadow_effect;
#line 109 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_scale_factor (_tmp4_, self->priv->scaling_factor);
#line 111 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	margin = gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_WRAPPER_PADDING, self->priv->scaling_factor);
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->container;
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_left (_tmp5_, (gfloat) margin);
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->container;
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_right (_tmp6_, (gfloat) margin);
#line 115 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = self->priv->container;
#line 115 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_bottom (_tmp7_, (gfloat) margin);
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->container;
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_top (_tmp8_, (gfloat) margin);
#line 118 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->caption;
#line 118 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_left ((ClutterActor*) _tmp9_, (gfloat) margin);
#line 119 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = self->priv->caption;
#line 119 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_right ((ClutterActor*) _tmp10_, (gfloat) margin);
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = self->priv->caption;
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_bottom ((ClutterActor*) _tmp11_, (gfloat) margin);
#line 426 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_get_preferred_width (ClutterActor* base,
                                               gfloat for_height,
                                               gfloat* min_width,
                                               gfloat* natural_width)
{
	GalaWindowSwitcher * self;
	gfloat _vala_min_width = 0.0F;
	gfloat _vala_natural_width = 0.0F;
	gfloat preferred_nat_width = 0.0F;
	gfloat _tmp0_ = 0.0F;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp1_;
	MetaDisplay* _tmp2_;
	gint monitor = 0;
	MtkRectangle geom = {0};
	MtkRectangle _tmp3_ = {0};
	gfloat container_nat_width = 0.0F;
	ClutterActor* _tmp4_;
	gfloat _tmp5_ = 0.0F;
	gfloat max_width = 0.0F;
	MtkRectangle _tmp6_;
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 124 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_vala_min_width = (gfloat) 0;
#line 127 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	CLUTTER_ACTOR_CLASS (gala_window_switcher_parent_class)->get_preferred_width ((ClutterActor*) G_TYPE_CHECK_INSTANCE_CAST (self, GALA_TYPE_CANVAS_ACTOR, GalaCanvasActor), for_height, NULL, &_tmp0_);
#line 127 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	preferred_nat_width = _tmp0_;
#line 129 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->_wm;
#line 129 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) _tmp1_);
#line 129 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp2_;
#line 130 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor = meta_display_get_current_monitor (display);
#line 131 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_display_get_monitor_geometry (display, monitor, &_tmp3_);
#line 131 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	geom = _tmp3_;
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_size (_tmp4_, NULL, NULL, &_tmp5_, NULL);
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	container_nat_width = _tmp5_;
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = geom;
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	max_width = MIN ((gfloat) (_tmp6_.width - (gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_MIN_OFFSET, self->priv->scaling_factor) * 2)), container_nat_width);
#line 141 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_vala_natural_width = MIN (max_width, preferred_nat_width);
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (min_width) {
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		*min_width = _vala_min_width;
#line 487 "WindowSwitcher.c"
	}
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (natural_width) {
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		*natural_width = _vala_natural_width;
#line 493 "WindowSwitcher.c"
	}
}

static ClutterColor*
_vala_clutter_color_from_string (const gchar* str)
{
	ClutterColor* color = NULL;
	ClutterColor* _tmp0_;
	ClutterColor* result;
#line 7865 "mutter-clutter-14.vapi"
	g_return_val_if_fail (str != NULL, NULL);
#line 7866 "mutter-clutter-14.vapi"
	_tmp0_ = clutter_color_alloc ();
#line 7866 "mutter-clutter-14.vapi"
	color = _tmp0_;
#line 7867 "mutter-clutter-14.vapi"
	clutter_color_from_string (color, str);
#line 7868 "mutter-clutter-14.vapi"
	result = color;
#line 7868 "mutter-clutter-14.vapi"
	return result;
#line 515 "WindowSwitcher.c"
}

static void
_vala_ClutterColor_free (ClutterColor* self)
{
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_boxed_free (clutter_color_get_type (), self);
#line 523 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_draw (GalaCanvasActor* base,
                                cairo_t* ctx,
                                gint width,
                                gint height)
{
	GalaWindowSwitcher * self;
	gchar* caption_color = NULL;
	gchar* _tmp0_;
	GalaDrawingStyleManager* _tmp1_;
	GalaDrawingStyleManagerColorScheme _tmp2_;
	GalaDrawingStyleManagerColorScheme _tmp3_;
	ClutterText* _tmp5_;
	const gchar* _tmp6_;
	ClutterColor* _tmp7_;
	ClutterColor* _tmp8_;
	ClutterColor _tmp9_;
	GdkRGBA background_color = {0};
	GalaDrawingStyleManager* _tmp10_;
	GalaDrawingStyleManagerColorScheme _tmp11_;
	GalaDrawingStyleManagerColorScheme _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	GdkRGBA _tmp15_;
	GdkRGBA _tmp16_;
#line 144 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 144 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (ctx != NULL);
#line 145 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = g_strdup ("#2e2e31");
#line 145 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	caption_color = _tmp0_;
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->style_manager;
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = gala_drawing_style_manager_get_prefers_color_scheme (_tmp1_);
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = _tmp2_;
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == GALA_DRAWING_STYLE_MANAGER_COLOR_SCHEME_DARK) {
#line 567 "WindowSwitcher.c"
		gchar* _tmp4_;
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = g_strdup ("#fafafa");
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_free0 (caption_color);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		caption_color = _tmp4_;
#line 575 "WindowSwitcher.c"
	}
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->caption;
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = caption_color;
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _vala_clutter_color_from_string (_tmp6_);
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = *_tmp8_;
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_color (_tmp5_, &_tmp9_);
#line 151 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__vala_ClutterColor_free0 (_tmp8_);
#line 153 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_save (ctx);
#line 154 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 155 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_paint (ctx);
#line 156 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_clip (ctx);
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_reset_clip (ctx);
#line 159 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	background_color = GALA_DRAWING_COLOR_LIGHT_BACKGROUND;
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = self->priv->style_manager;
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = gala_drawing_style_manager_get_prefers_color_scheme (_tmp10_);
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = _tmp11_;
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp12_ == GALA_DRAWING_STYLE_MANAGER_COLOR_SCHEME_DARK) {
#line 161 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		background_color = GALA_DRAWING_COLOR_DARK_BACKGROUND;
#line 613 "WindowSwitcher.c"
	}
#line 164 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
#line 165 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = background_color;
#line 165 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = background_color;
#line 165 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = background_color;
#line 165 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = background_color;
#line 165 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_source_rgba (ctx, _tmp13_.red, _tmp14_.green, _tmp15_.blue, _tmp16_.alpha);
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_drawing_utilities_cairo_rounded_rectangle (ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height, (gdouble) gala_internal_utils_scale_to_int (6, self->priv->scaling_factor));
#line 172 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_fill (ctx);
#line 173 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_restore (ctx);
#line 144 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (caption_color);
#line 635 "WindowSwitcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 643 "WindowSwitcher.c"
}

void
gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                            MetaWindow* window,
                                            ClutterKeyEvent* event,
                                            MetaKeyBinding* binding,
                                            GalaWindowSwitcher* self)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspaceManager* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	guint mask = 0U;
	gboolean _tmp3_;
	gchar* binding_name = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean backward = FALSE;
	const gchar* _tmp9_;
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (display != NULL);
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (event != NULL);
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (binding != NULL);
#line 181 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (self->priv->handling_gesture) {
#line 182 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 676 "WindowSwitcher.c"
	}
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_workspace_manager (display);
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_workspace_manager_get_active_workspace (_tmp0_);
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	workspace = _tmp2_;
#line 188 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	mask = meta_key_binding_get_mask (binding);
#line 189 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (mask == ((guint) 0)) {
#line 190 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 0;
#line 692 "WindowSwitcher.c"
	} else {
#line 192 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 1;
#line 193 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		while (TRUE) {
#line 193 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!(mask > ((guint) 1))) {
#line 193 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				break;
#line 702 "WindowSwitcher.c"
			}
#line 194 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			mask >>= (guint) 1;
#line 195 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			self->priv->modifier_mask = self->priv->modifier_mask << 1;
#line 708 "WindowSwitcher.c"
		}
	}
#line 199 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_opened;
#line 199 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp3_) {
#line 715 "WindowSwitcher.c"
		gboolean windows_exist = FALSE;
		const gchar* _tmp4_;
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = meta_key_binding_get_name (binding);
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (g_str_has_prefix (_tmp4_, "switch-group")) {
#line 722 "WindowSwitcher.c"
			MetaWorkspace* _tmp5_;
#line 202 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp5_ = workspace;
#line 202 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_current_windows (self, display, _tmp5_);
#line 728 "WindowSwitcher.c"
		} else {
			MetaWorkspace* _tmp6_;
#line 204 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp6_ = workspace;
#line 204 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_all_windows (self, display, _tmp6_);
#line 735 "WindowSwitcher.c"
		}
#line 207 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!windows_exist) {
#line 208 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (workspace);
#line 208 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return;
#line 743 "WindowSwitcher.c"
		}
#line 211 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_open_switcher (self);
#line 747 "WindowSwitcher.c"
	}
#line 214 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = meta_key_binding_get_name (binding);
#line 214 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 214 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	binding_name = _tmp8_;
#line 215 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = binding_name;
#line 215 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	backward = g_str_has_suffix (_tmp9_, "-backward");
#line 217 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_next_window (self, backward);
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (binding_name);
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 765 "WindowSwitcher.c"
}

static Block71Data*
block71_data_ref (Block71Data* _data71_)
{
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_atomic_int_inc (&_data71_->_ref_count_);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return _data71_;
#line 775 "WindowSwitcher.c"
}

static void
block71_data_unref (void * _userdata_)
{
	Block71Data* _data71_;
	_data71_ = (Block71Data*) _userdata_;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data71_->_ref_count_)) {
#line 785 "WindowSwitcher.c"
		GalaWindowSwitcher* self;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self = _data71_->self;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_slice_free (Block71Data, _data71_);
#line 793 "WindowSwitcher.c"
	}
}

static void
__lambda84_ (Block71Data* _data71_,
             gdouble percentage)
{
	GalaWindowSwitcher* self;
	gfloat window_index = 0.0F;
	ClutterActor* _tmp0_;
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = _data71_->self;
#line 236 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window_index = gala_gesture_tracker_animation_value ((gfloat) 0, (gfloat) GALA_WINDOW_SWITCHER_GESTURE_RANGE_LIMIT, percentage, TRUE);
#line 238 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 238 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (window_index >= ((gfloat) clutter_actor_get_n_children (_tmp0_))) {
#line 239 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 814 "WindowSwitcher.c"
	}
#line 242 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (window_index > ((gfloat) _data71_->last_window_index)) {
#line 243 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		while (TRUE) {
#line 820 "WindowSwitcher.c"
			gint _tmp1_;
#line 243 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!(((gfloat) _data71_->last_window_index) < window_index)) {
#line 243 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				break;
#line 826 "WindowSwitcher.c"
			}
#line 244 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_next_window (self, _data71_->direction == GALA_GESTURE_DIRECTION_LEFT);
#line 245 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp1_ = _data71_->last_window_index;
#line 245 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_data71_->last_window_index = _tmp1_ + 1;
#line 834 "WindowSwitcher.c"
		}
	} else {
#line 247 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (window_index < ((gfloat) _data71_->last_window_index)) {
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			while (TRUE) {
#line 841 "WindowSwitcher.c"
				gint _tmp2_;
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (!(((gfloat) _data71_->last_window_index) > window_index)) {
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					break;
#line 847 "WindowSwitcher.c"
				}
#line 249 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, _data71_->direction == GALA_GESTURE_DIRECTION_RIGHT);
#line 250 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp2_ = _data71_->last_window_index;
#line 250 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_data71_->last_window_index = _tmp2_ - 1;
#line 855 "WindowSwitcher.c"
			}
		}
	}
}

static void
___lambda84__gala_gesture_tracker_on_update (gdouble percentage,
                                             gpointer self)
{
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__lambda84_ (self, percentage);
#line 867 "WindowSwitcher.c"
}

static void
__lambda85_ (GalaWindowSwitcher* self,
             gdouble percentage,
             gboolean cancel_action,
             gint calculated_duration)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
#line 256 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = FALSE;
#line 257 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 257 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 257 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp1_), FALSE);
#line 886 "WindowSwitcher.c"
}

static void
___lambda85__gala_gesture_tracker_on_end (gdouble percentage,
                                          gboolean cancel_action,
                                          gint calculated_duration,
                                          gpointer self)
{
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__lambda85_ ((GalaWindowSwitcher*) self, percentage, cancel_action, calculated_duration);
#line 897 "WindowSwitcher.c"
}

void
gala_window_switcher_handle_gesture (GalaWindowSwitcher* self,
                                     GalaGestureDirection direction)
{
	Block71Data* _data71_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	gboolean windows_exist = FALSE;
	MetaDisplay* _tmp6_;
	MetaWorkspace* _tmp7_;
	gint _tmp8_ = 0;
	GalaGestureTrackerOnUpdate on_animation_update = NULL;
	gpointer on_animation_update_target;
	GDestroyNotify on_animation_update_target_destroy_notify;
	GalaGestureTrackerOnEnd on_animation_end = NULL;
	gpointer on_animation_end_target;
	GDestroyNotify on_animation_end_target_destroy_notify;
	GalaGestureTracker* _tmp9_;
	GalaGestureTrackerOnUpdate _tmp10_;
	gpointer _tmp10__target;
	GDestroyNotify _tmp10__target_destroy_notify;
	GalaGestureTrackerOnEnd _tmp11_;
	gpointer _tmp11__target;
	GDestroyNotify _tmp11__target_destroy_notify;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data71_ = g_slice_new0 (Block71Data);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data71_->_ref_count_ = 1;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data71_->self = g_object_ref (self);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data71_->direction = direction;
#line 221 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = TRUE;
#line 223 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 223 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 223 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp1_;
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = display;
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	workspace_manager = _tmp3_;
#line 225 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = workspace_manager;
#line 225 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 225 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	active_workspace = _tmp5_;
#line 227 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = display;
#line 227 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = active_workspace;
#line 227 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows_exist = gala_window_switcher_collect_all_windows (self, _tmp6_, _tmp7_);
#line 228 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!windows_exist) {
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		block71_data_unref (_data71_);
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_data71_ = NULL;
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 975 "WindowSwitcher.c"
	}
#line 231 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_open_switcher (self);
#line 234 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_data71_->direction == GALA_GESTURE_DIRECTION_RIGHT) {
#line 234 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = 0;
#line 983 "WindowSwitcher.c"
	} else {
#line 234 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = -1;
#line 987 "WindowSwitcher.c"
	}
#line 234 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data71_->last_window_index = _tmp8_;
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = ___lambda84__gala_gesture_tracker_on_update;
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = block71_data_ref (_data71_);
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = block71_data_unref;
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = ___lambda85__gala_gesture_tracker_on_end;
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = g_object_ref (self);
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = g_object_unref;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->_gesture_tracker;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = on_animation_update;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10__target = on_animation_update_target;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10__target_destroy_notify = on_animation_update_target_destroy_notify;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = NULL;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = NULL;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = on_animation_end;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11__target = on_animation_end_target;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11__target_destroy_notify = on_animation_end_target_destroy_notify;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = NULL;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = NULL;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_tracker_connect_handlers (_tmp9_, NULL, NULL, NULL, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify, _tmp11_, _tmp11__target, _tmp11__target_destroy_notify);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(on_animation_end_target_destroy_notify == NULL) ? NULL : (on_animation_end_target_destroy_notify (on_animation_end_target), NULL);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = NULL;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = NULL;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(on_animation_update_target_destroy_notify == NULL) ? NULL : (on_animation_update_target_destroy_notify (on_animation_update_target), NULL);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = NULL;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = NULL;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	block71_data_unref (_data71_);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data71_ = NULL;
#line 1051 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                          MetaDisplay* display,
                                          MetaWorkspace* workspace)
{
	GList* windows = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	ClutterActor* _tmp4_;
	GList* _tmp5_;
	gboolean result;
#line 263 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 263 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 264 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 264 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp0_;
#line 265 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = windows;
#line 265 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_ == NULL) {
#line 266 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 266 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 266 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1086 "WindowSwitcher.c"
	}
#line 269 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 269 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp2_;
#line 270 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = current_window;
#line 270 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == NULL) {
#line 271 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, NULL);
#line 1098 "WindowSwitcher.c"
	}
#line 274 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 274 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_remove_all_children (_tmp4_);
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = windows;
#line 1106 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp5_;
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1114 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1118 "WindowSwitcher.c"
			{
				GalaWindowSwitcherIcon* icon = NULL;
				MetaWindow* _tmp6_;
				GalaWindowSwitcherIcon* _tmp7_;
				MetaWindow* _tmp8_;
				MetaWindow* _tmp9_;
				GalaWindowSwitcherIcon* _tmp11_;
#line 277 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp6_ = window;
#line 277 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp7_ = gala_window_switcher_icon_new (_tmp6_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 277 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				g_object_ref_sink (_tmp7_);
#line 277 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				icon = _tmp7_;
#line 278 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp8_ = window;
#line 278 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp9_ = current_window;
#line 278 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp8_ == _tmp9_) {
#line 1140 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* _tmp10_;
#line 279 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp10_ = icon;
#line 279 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_window_switcher_set_current_icon (self, _tmp10_);
#line 1146 "WindowSwitcher.c"
				}
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp11_ = icon;
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_add_icon (self, _tmp11_);
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (icon);
#line 1154 "WindowSwitcher.c"
			}
		}
	}
#line 285 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 285 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 285 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1164 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                              MetaDisplay* display,
                                              MetaWorkspace* workspace)
{
	GList* windows = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	ClutterActor* _tmp4_;
	GalaWindowTracker* window_tracker = NULL;
	GalaWindowManager* _tmp5_;
	GalaWindowTracker* _tmp6_;
	GalaWindowTracker* _tmp7_;
	GalaApp* app = NULL;
	GalaWindowTracker* _tmp8_;
	MetaWindow* _tmp9_;
	GalaApp* _tmp10_;
	GList* _tmp11_;
	gboolean result;
#line 288 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 288 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp0_;
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = windows;
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_ == NULL) {
#line 291 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 291 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 291 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1207 "WindowSwitcher.c"
	}
#line 294 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 294 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp2_;
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = current_window;
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == NULL) {
#line 296 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, NULL);
#line 297 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 297 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 297 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1225 "WindowSwitcher.c"
	}
#line 300 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 300 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_remove_all_children (_tmp4_);
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->_wm;
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = gala_window_manager_gala_get_window_tracker (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala));
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _tmp6_;
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window_tracker = _tmp7_;
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = window_tracker;
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = current_window;
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = gala_window_tracker_get_app_for_window (_tmp8_, _tmp9_);
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	app = _tmp10_;
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = windows;
#line 1249 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp11_;
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1257 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1261 "WindowSwitcher.c"
			{
				GalaWindowTracker* _tmp12_;
				MetaWindow* _tmp13_;
				GalaApp* _tmp14_;
				GalaApp* _tmp15_;
				GalaApp* _tmp16_;
				gboolean _tmp17_;
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp12_ = window_tracker;
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp13_ = window;
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp14_ = gala_window_tracker_get_app_for_window (_tmp12_, _tmp13_);
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp15_ = _tmp14_;
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp16_ = app;
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp17_ = _tmp15_ == _tmp16_;
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (_tmp15_);
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp17_) {
#line 1285 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* icon = NULL;
					MetaWindow* _tmp18_;
					GalaWindowSwitcherIcon* _tmp19_;
					MetaWindow* _tmp20_;
					MetaWindow* _tmp21_;
					GalaWindowSwitcherIcon* _tmp23_;
#line 306 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp18_ = window;
#line 306 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp19_ = gala_window_switcher_icon_new (_tmp18_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 306 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					g_object_ref_sink (_tmp19_);
#line 306 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					icon = _tmp19_;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp20_ = window;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp21_ = current_window;
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					if (_tmp20_ == _tmp21_) {
#line 1306 "WindowSwitcher.c"
						GalaWindowSwitcherIcon* _tmp22_;
#line 308 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						_tmp22_ = icon;
#line 308 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						gala_window_switcher_set_current_icon (self, _tmp22_);
#line 1312 "WindowSwitcher.c"
					}
#line 311 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp23_ = icon;
#line 311 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_window_switcher_add_icon (self, _tmp23_);
#line 305 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_g_object_unref0 (icon);
#line 1320 "WindowSwitcher.c"
				}
			}
		}
	}
#line 315 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 315 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (app);
#line 315 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 315 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1333 "WindowSwitcher.c"
}

static Block72Data*
block72_data_ref (Block72Data* _data72_)
{
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_atomic_int_inc (&_data72_->_ref_count_);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return _data72_;
#line 1343 "WindowSwitcher.c"
}

static void
block72_data_unref (void * _userdata_)
{
	Block72Data* _data72_;
	_data72_ = (Block72Data*) _userdata_;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data72_->_ref_count_)) {
#line 1353 "WindowSwitcher.c"
		GalaWindowSwitcher* self;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self = _data72_->self;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (_data72_->icon);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_slice_free (Block72Data, _data72_);
#line 1363 "WindowSwitcher.c"
	}
}

static gboolean
__lambda82_ (Block72Data* _data72_)
{
	GalaWindowSwitcher* self;
	gboolean _tmp0_ = FALSE;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	gboolean result;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = _data72_->self;
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_ != _data72_->icon) {
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 1385 "WindowSwitcher.c"
	} else {
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 1389 "WindowSwitcher.c"
	}
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 323 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, _data72_->icon);
#line 1395 "WindowSwitcher.c"
	}
#line 326 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 326 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1401 "WindowSwitcher.c"
}

static gboolean
___lambda82__clutter_actor_motion_event (ClutterActor* _sender,
                                         ClutterEvent* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda82_ (self);
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1413 "WindowSwitcher.c"
}

static void
gala_window_switcher_add_icon (GalaWindowSwitcher* self,
                               GalaWindowSwitcherIcon* icon)
{
	Block72Data* _data72_;
	GalaWindowSwitcherIcon* _tmp0_;
	ClutterActor* _tmp1_;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (icon != NULL);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_ = g_slice_new0 (Block72Data);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_->_ref_count_ = 1;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_->self = g_object_ref (self);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = _g_object_ref0 (icon);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_data72_->icon);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_->icon = _tmp0_;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->container;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child (_tmp1_, (ClutterActor*) _data72_->icon);
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_data ((ClutterActor*) _data72_->icon, "motion-event", (GCallback) ___lambda82__clutter_actor_motion_event, block72_data_ref (_data72_), (GClosureNotify) block72_data_unref, 0);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	block72_data_unref (_data72_);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_ = NULL;
#line 1449 "WindowSwitcher.c"
}

static void
gala_window_switcher_open_switcher (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	gboolean _tmp3_;
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	gfloat _tmp4_ = 0.0F;
	gfloat _tmp5_ = 0.0F;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp6_;
	MetaDisplay* _tmp7_;
	gint monitor = 0;
	MetaDisplay* _tmp8_;
	MtkRectangle geom = {0};
	MetaDisplay* _tmp9_;
	MtkRectangle _tmp10_ = {0};
	MtkRectangle _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	MtkRectangle _tmp14_;
#line 330 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 331 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 331 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp0_) == 0) {
#line 1479 "WindowSwitcher.c"
		ClutterBackend* _tmp1_;
		ClutterSeat* _tmp2_;
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = clutter_get_default_backend ();
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = clutter_backend_get_default_seat (_tmp1_);
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_seat_bell_notify (_tmp2_);
#line 333 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1490 "WindowSwitcher.c"
	}
#line 336 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_opened;
#line 336 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_) {
#line 337 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1498 "WindowSwitcher.c"
	}
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_size ((ClutterActor*) self, NULL, NULL, &_tmp4_, &_tmp5_);
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	width = _tmp4_;
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	height = _tmp5_;
#line 347 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->_wm;
#line 347 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = meta_plugin_get_display ((MetaPlugin*) _tmp6_);
#line 347 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp7_;
#line 348 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = display;
#line 348 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor = meta_display_get_current_monitor (_tmp8_);
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = display;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_display_get_monitor_geometry (_tmp9_, monitor, &_tmp10_);
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	geom = _tmp10_;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = geom;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = geom;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = geom;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = geom;
#line 351 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_position ((ClutterActor*) self, (gfloat) ((gint) (_tmp11_.x + ((_tmp12_.width - width) / 2))), (gfloat) ((gint) (_tmp13_.y + ((_tmp14_.height - height) / 2))));
#line 356 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, TRUE);
#line 1536 "WindowSwitcher.c"
}

static void
gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                     gboolean show)
{
	gboolean _tmp0_;
	gint _tmp3_ = 0;
	GalaWindowManager* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gint _tmp7_ = 0;
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 360 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ == show) {
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1557 "WindowSwitcher.c"
	}
#line 364 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_set_opened (self, show);
#line 365 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 366 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_push_modal (self);
#line 1565 "WindowSwitcher.c"
	} else {
		GalaWindowManager* _tmp1_;
		GalaModalProxy* _tmp2_;
#line 368 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_wm;
#line 368 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = self->priv->modal_proxy;
#line 368 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_manager_pop_modal (_tmp1_, _tmp2_);
#line 1575 "WindowSwitcher.c"
	}
#line 371 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->_wm;
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = gala_window_manager_get_enable_animations (_tmp4_);
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = _tmp5_;
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp6_) {
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = GALA_WINDOW_SWITCHER_ANIMATION_DURATION;
#line 1589 "WindowSwitcher.c"
	} else {
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = 0;
#line 1593 "WindowSwitcher.c"
	}
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) _tmp3_);
#line 373 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 373 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = 255;
#line 1601 "WindowSwitcher.c"
	} else {
#line 373 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = 0;
#line 1605 "WindowSwitcher.c"
	}
#line 373 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) _tmp7_);
#line 374 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 1611 "WindowSwitcher.c"
}

static gboolean
__lambda83_ (GalaWindowSwitcher* self,
             MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	gboolean result;
#line 379 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (action) {
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS:
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS_BACKWARD:
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS:
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS_BACKWARD:
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP:
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP_BACKWARD:
#line 1645 "WindowSwitcher.c"
		{
#line 391 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = FALSE;
#line 391 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 1651 "WindowSwitcher.c"
		}
		default:
		{
#line 393 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			break;
#line 1657 "WindowSwitcher.c"
		}
	}
#line 396 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 396 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1664 "WindowSwitcher.c"
}

static gboolean
___lambda83__gala_keybinding_filter (MetaKeyBinding* binding,
                                     gpointer self)
{
	gboolean result;
	result = __lambda83_ ((GalaWindowSwitcher*) self, binding);
#line 379 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1675 "WindowSwitcher.c"
}

static void
gala_window_switcher_push_modal (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaModalProxy* _tmp2_;
#line 377 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 378 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 378 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_manager_push_modal (_tmp0_, (ClutterActor*) self);
#line 378 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 378 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = _tmp1_;
#line 379 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->modal_proxy;
#line 379 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp2_, ___lambda83__gala_keybinding_filter, self);
#line 1698 "WindowSwitcher.c"
}

static void
gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                     guint32 time,
                                     gboolean cancel)
{
	gboolean _tmp0_;
	MetaWindow* window = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp5_;
	MetaWindow* _tmp6_;
#line 401 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp0_) {
#line 403 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1722 "WindowSwitcher.c"
	}
#line 406 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 406 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 406 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = gala_window_switcher_icon_get_window (_tmp2_);
#line 406 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 406 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 406 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window = _tmp5_;
#line 407 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = window;
#line 407 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp6_ == NULL) {
#line 408 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (window);
#line 408 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1744 "WindowSwitcher.c"
	}
#line 411 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!cancel) {
#line 1748 "WindowSwitcher.c"
		MetaWorkspace* workspace = NULL;
		MetaWindow* _tmp7_;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp9_;
		GalaWindowManager* _tmp10_;
		MetaDisplay* _tmp11_;
		MetaWorkspaceManager* _tmp12_;
		MetaWorkspace* _tmp13_;
#line 412 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = window;
#line 412 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = meta_window_get_workspace (_tmp7_);
#line 412 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		workspace = _tmp8_;
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = workspace;
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = self->priv->_wm;
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_plugin_get_display ((MetaPlugin*) _tmp10_);
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = meta_display_get_workspace_manager (_tmp11_);
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp13_ = meta_workspace_manager_get_active_workspace (_tmp12_);
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (_tmp9_ != _tmp13_) {
#line 1775 "WindowSwitcher.c"
			MetaWorkspace* _tmp14_;
			MetaWindow* _tmp15_;
#line 414 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = workspace;
#line 414 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp15_ = window;
#line 414 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_workspace_activate_with_focus (_tmp14_, _tmp15_, time);
#line 1784 "WindowSwitcher.c"
		} else {
			MetaWindow* _tmp16_;
#line 416 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp16_ = window;
#line 416 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_window_activate (_tmp16_, time);
#line 1791 "WindowSwitcher.c"
		}
	}
#line 420 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, FALSE);
#line 401 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (window);
#line 1798 "WindowSwitcher.c"
}

static void
gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                  gboolean backward)
{
	ClutterActor* actor = NULL;
	gboolean _tmp0_ = FALSE;
	ClutterActor* _tmp1_;
	GalaWindowSwitcherIcon* _tmp6_;
	GalaWindowSwitcherIcon* _tmp7_;
	ClutterActor* _tmp27_;
#line 423 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->container;
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp1_) == 1) {
#line 1817 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp2_;
		GalaWindowSwitcherIcon* _tmp3_;
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = gala_window_switcher_get_current_icon (self);
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 1826 "WindowSwitcher.c"
	} else {
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 1830 "WindowSwitcher.c"
	}
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 1834 "WindowSwitcher.c"
		ClutterBackend* _tmp4_;
		ClutterSeat* _tmp5_;
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = clutter_get_default_backend ();
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = clutter_backend_get_default_seat (_tmp4_);
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_seat_bell_notify (_tmp5_);
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1847 "WindowSwitcher.c"
	}
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = gala_window_switcher_get_current_icon (self);
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _tmp6_;
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp7_ == NULL) {
#line 1855 "WindowSwitcher.c"
		ClutterActor* _tmp8_;
		ClutterActor* _tmp9_;
		ClutterActor* _tmp10_;
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = self->priv->container;
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = clutter_actor_get_first_child (_tmp8_);
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		actor = _tmp10_;
#line 1869 "WindowSwitcher.c"
	} else {
#line 433 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!backward) {
#line 1873 "WindowSwitcher.c"
			GalaWindowSwitcherIcon* _tmp11_;
			GalaWindowSwitcherIcon* _tmp12_;
			ClutterActor* _tmp13_;
			ClutterActor* _tmp14_;
			ClutterActor* _tmp15_;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp11_ = gala_window_switcher_get_current_icon (self);
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp12_ = _tmp11_;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp13_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp12_);
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = _g_object_ref0 (_tmp13_);
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			actor = _tmp14_;
#line 435 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp15_ = actor;
#line 435 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (_tmp15_ == NULL) {
#line 1895 "WindowSwitcher.c"
				ClutterActor* _tmp16_;
				ClutterActor* _tmp17_;
				ClutterActor* _tmp18_;
#line 436 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp16_ = self->priv->container;
#line 436 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp17_ = clutter_actor_get_first_child (_tmp16_);
#line 436 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 436 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (actor);
#line 436 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				actor = _tmp18_;
#line 1909 "WindowSwitcher.c"
			}
		} else {
			GalaWindowSwitcherIcon* _tmp19_;
			GalaWindowSwitcherIcon* _tmp20_;
			ClutterActor* _tmp21_;
			ClutterActor* _tmp22_;
			ClutterActor* _tmp23_;
#line 439 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp19_ = gala_window_switcher_get_current_icon (self);
#line 439 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp20_ = _tmp19_;
#line 439 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp21_ = clutter_actor_get_previous_sibling ((ClutterActor*) _tmp20_);
#line 439 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 439 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 439 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			actor = _tmp22_;
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp23_ = actor;
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (_tmp23_ == NULL) {
#line 1933 "WindowSwitcher.c"
				ClutterActor* _tmp24_;
				ClutterActor* _tmp25_;
				ClutterActor* _tmp26_;
#line 441 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp24_ = self->priv->container;
#line 441 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp25_ = clutter_actor_get_last_child (_tmp24_);
#line 441 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp26_ = _g_object_ref0 (_tmp25_);
#line 441 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (actor);
#line 441 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				actor = _tmp26_;
#line 1947 "WindowSwitcher.c"
			}
		}
	}
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp27_ = actor;
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_set_current_icon (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon));
#line 423 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 1957 "WindowSwitcher.c"
}

static void
gala_window_switcher_update_caption_text (GalaWindowSwitcher* self)
{
	MetaWindow* _tmp0_ = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp7_;
	const gchar* _tmp8_ = NULL;
	MetaWindow* _tmp9_;
	gchar* current_caption = NULL;
	gchar* _tmp13_;
	ClutterText* _tmp14_;
#line 448 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_ != NULL) {
#line 1981 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp3_;
		GalaWindowSwitcherIcon* _tmp4_;
		MetaWindow* _tmp5_;
		MetaWindow* _tmp6_;
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = gala_window_switcher_get_current_icon (self);
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = _tmp3_;
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = gala_window_switcher_icon_get_window (_tmp4_);
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _tmp6_;
#line 1996 "WindowSwitcher.c"
	} else {
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = NULL;
#line 2000 "WindowSwitcher.c"
	}
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _g_object_ref0 (_tmp0_);
#line 449 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp7_;
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = current_window;
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp9_ != NULL) {
#line 2010 "WindowSwitcher.c"
		MetaWindow* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = current_window;
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_window_get_title (_tmp10_);
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = _tmp11_;
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = _tmp12_;
#line 2022 "WindowSwitcher.c"
	} else {
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = "n/a";
#line 2026 "WindowSwitcher.c"
	}
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = g_strdup (_tmp8_);
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_caption = _tmp13_;
#line 451 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = self->priv->caption;
#line 451 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_text (_tmp14_, current_caption);
#line 448 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (current_caption);
#line 448 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (current_window);
#line 2040 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_key_focus_out (ClutterActor* base)
{
	GalaWindowSwitcher * self;
#line 454 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!self->priv->handling_gesture) {
#line 2051 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
		MetaDisplay* _tmp1_;
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = self->priv->_wm;
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp1_), FALSE);
#line 2060 "WindowSwitcher.c"
	}
}

static gboolean
gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                              ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean result;
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->_opened;
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_) {
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY;
#line 2082 "WindowSwitcher.c"
	} else {
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = FALSE;
#line 2086 "WindowSwitcher.c"
	}
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_) {
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 2092 "WindowSwitcher.c"
	} else {
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2096 "WindowSwitcher.c"
	}
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 466 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2102 "WindowSwitcher.c"
	}
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2108 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_release_event (ClutterActor* base,
                                             ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 473 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 473 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 477 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
#line 477 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 2126 "WindowSwitcher.c"
	} else {
#line 477 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2130 "WindowSwitcher.c"
	}
#line 477 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 478 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2136 "WindowSwitcher.c"
	}
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2142 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean result;
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (clutter_event_get_key_symbol (event)) {
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Right:
#line 2159 "WindowSwitcher.c"
		{
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!self->priv->handling_gesture) {
#line 492 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, FALSE);
#line 2165 "WindowSwitcher.c"
			}
#line 494 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 494 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2171 "WindowSwitcher.c"
		}
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Left:
#line 2175 "WindowSwitcher.c"
		{
#line 496 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!self->priv->handling_gesture) {
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, TRUE);
#line 2181 "WindowSwitcher.c"
			}
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2187 "WindowSwitcher.c"
		}
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Escape:
#line 2191 "WindowSwitcher.c"
		{
#line 501 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), TRUE);
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2199 "WindowSwitcher.c"
		}
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Return:
#line 2203 "WindowSwitcher.c"
		{
#line 504 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2211 "WindowSwitcher.c"
		}
		default:
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2216 "WindowSwitcher.c"
	}
#line 508 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 508 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2222 "WindowSwitcher.c"
}

static inline ClutterModifierType
gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self)
{
	ClutterModifierType modifiers = 0U;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaCursorTracker* _tmp2_;
	ClutterModifierType _tmp3_ = 0U;
	ClutterModifierType result;
#line 512 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_cursor_tracker_get_for_display (_tmp1_);
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_cursor_tracker_get_pointer (_tmp2_, NULL, &_tmp3_);
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	modifiers = _tmp3_;
#line 516 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = modifiers & CLUTTER_MODIFIER_MASK;
#line 516 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2250 "WindowSwitcher.c"
}

GalaWindowManager*
gala_window_switcher_get_wm (GalaWindowSwitcher* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2266 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_wm (self);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 2280 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_wm);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_wm = _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY]);
#line 2290 "WindowSwitcher.c"
	}
}

GalaGestureTracker*
gala_window_switcher_get_gesture_tracker (GalaWindowSwitcher* self)
{
	GalaGestureTracker* result;
	GalaGestureTracker* _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_gesture_tracker;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2307 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_gesture_tracker (GalaWindowSwitcher* self,
                                          GalaGestureTracker* value)
{
	GalaGestureTracker* old_value;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_gesture_tracker (self);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 2321 "WindowSwitcher.c"
		GalaGestureTracker* _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_gesture_tracker);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_gesture_tracker = _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY]);
#line 2331 "WindowSwitcher.c"
	}
}

gboolean
gala_window_switcher_get_opened (GalaWindowSwitcher* self)
{
	gboolean result;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = self->priv->_opened;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2345 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                 gboolean value)
{
	gboolean old_value;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_opened (self);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_opened = value;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY]);
#line 2363 "WindowSwitcher.c"
	}
}

static GalaWindowSwitcherIcon*
gala_window_switcher_get_current_icon (GalaWindowSwitcher* self)
{
	GalaWindowSwitcherIcon* result;
	GalaWindowSwitcherIcon* _tmp0_;
#line 34 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2380 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                       GalaWindowSwitcherIcon* value)
{
	GalaWindowSwitcherIcon* _tmp0_;
	GalaWindowSwitcherIcon* _tmp2_;
	GalaWindowSwitcherIcon* _tmp3_;
#line 37 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 38 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 2396 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp1_;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_current_icon;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp1_, FALSE);
#line 2402 "WindowSwitcher.c"
	}
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = _tmp2_;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_current_icon;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ != NULL) {
#line 2414 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp4_;
#line 44 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = self->priv->_current_icon;
#line 44 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp4_, TRUE);
#line 2420 "WindowSwitcher.c"
	}
#line 47 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_update_caption_text (self);
#line 2424 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                  ClutterEvent* event,
                                                                                  gpointer self)
{
	gboolean result;
	result = gala_window_switcher_container_mouse_release ((GalaWindowSwitcher*) self, event);
#line 95 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2436 "WindowSwitcher.c"
}

static void
_clutter_content_invalidate_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self)
{
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_content_invalidate ((ClutterContent*) self);
#line 2446 "WindowSwitcher.c"
}

static void
_gala_window_switcher_scale_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                   gpointer self)
{
#line 101 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_scale ((GalaWindowSwitcher*) self);
#line 2455 "WindowSwitcher.c"
}

static void
_gala_window_switcher___lambda86_ (GalaWindowSwitcher* self)
{
	guint _tmp0_;
	guint _tmp1_;
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = clutter_actor_get_opacity ((ClutterActor*) self);
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", _tmp1_ != ((guint) 0), NULL);
#line 2469 "WindowSwitcher.c"
}

static void
__gala_window_switcher___lambda86__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gala_window_switcher___lambda86_ ((GalaWindowSwitcher*) self);
#line 2479 "WindowSwitcher.c"
}

static GObject *
gala_window_switcher_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowSwitcher * self;
	GalaDrawingStyleManager* _tmp0_;
	ClutterFlowLayout* _tmp1_;
	ClutterActor* _tmp2_ = NULL;
	gchar* _tmp3_;
	ClutterText* _tmp4_ = NULL;
	ClutterActor* _tmp5_;
	ClutterText* _tmp6_;
	ClutterBoxLayout* _tmp7_ = NULL;
	ClutterBoxLayout* _tmp8_;
	gchar* _tmp9_;
	GalaShadowEffect* _tmp10_ = NULL;
	GalaShadowEffect* _tmp11_;
	ClutterActor* _tmp12_;
	GalaDrawingStyleManager* _tmp13_;
	ClutterContent* _tmp14_;
	ClutterContent* _tmp15_;
	MetaMonitorManager* monitor_manager = NULL;
	GalaWindowManager* _tmp16_;
	MetaDisplay* _tmp17_;
	MetaContext* _tmp18_;
	MetaBackend* _tmp19_;
	MetaMonitorManager* _tmp20_;
	MetaMonitorManager* _tmp21_;
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	parent_class = G_OBJECT_CLASS (gala_window_switcher_parent_class);
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = gala_drawing_style_manager_get_instance ();
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->style_manager = _tmp0_;
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = (ClutterFlowLayout*) clutter_flow_layout_new (CLUTTER_ORIENTATION_HORIZONTAL);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp1_);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = clutter_actor_new ();
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_reactive (_tmp2_, TRUE);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_layout_manager (_tmp2_, (ClutterLayoutManager*) _tmp1_);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_tmp1_);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp2_);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->container = _tmp2_;
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = g_strdup (GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = (ClutterText*) clutter_text_new ();
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_font_name (_tmp4_, _tmp3_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (_tmp3_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_ellipsize (_tmp4_, PANGO_ELLIPSIZE_END);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_line_alignment (_tmp4_, PANGO_ALIGN_CENTER);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp4_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->caption = _tmp4_;
#line 78 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->container;
#line 78 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp5_);
#line 79 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->caption;
#line 79 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp6_);
#line 81 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 82 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = (ClutterBoxLayout*) clutter_box_layout_new ();
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_box_layout_set_orientation (_tmp7_, CLUTTER_ORIENTATION_VERTICAL);
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp7_);
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_layout_manager ((ClutterActor*) self, (ClutterLayoutManager*) _tmp8_);
#line 83 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_tmp8_);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = g_strdup ("window-switcher");
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = gala_shadow_effect_new (40);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_shadow_opacity (_tmp10_, (guint8) 200);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_css_class (_tmp10_, _tmp9_);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (_tmp9_);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp10_);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->shadow_effect);
#line 87 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->shadow_effect = _tmp10_;
#line 91 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = self->priv->shadow_effect;
#line 91 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_effect ((ClutterActor*) self, (ClutterEffect*) _tmp11_);
#line 93 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_scale (self);
#line 95 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = self->priv->container;
#line 95 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp12_, "button-release-event", (GCallback) _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event, self, 0);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = self->priv->style_manager;
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = clutter_actor_get_content ((ClutterActor*) self);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = _tmp14_;
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::prefers-color-scheme", (GCallback) _clutter_content_invalidate_g_object_notify, _tmp15_, 0);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = self->priv->_wm;
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = meta_plugin_get_display ((MetaPlugin*) _tmp16_);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = meta_display_get_context (_tmp17_);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = meta_context_get_backend (_tmp18_);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = meta_backend_get_monitor_manager (_tmp19_);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor_manager = _tmp20_;
#line 101 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = monitor_manager;
#line 101 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp21_, "monitors-changed", (GCallback) _gala_window_switcher_scale_meta_monitor_manager_monitors_changed, self, 0);
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) self, "notify::opacity", (GCallback) __gala_window_switcher___lambda86__g_object_notify, self, 0);
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return obj;
#line 2639 "WindowSwitcher.c"
}

static void
gala_window_switcher_class_init (GalaWindowSwitcherClass * klass,
                                 gpointer klass_data)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowSwitcher_private_offset);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->get_preferred_width = (void (*) (ClutterActor*, gfloat, gfloat*, gfloat*)) gala_window_switcher_real_get_preferred_width;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((GalaCanvasActorClass *) klass)->draw = (void (*) (GalaCanvasActor*, cairo_t*, gint, gint)) gala_window_switcher_real_draw;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_switcher_real_key_focus_out;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_release_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_press_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_switcher_get_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_switcher_set_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_switcher_constructor;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_switcher_finalize;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_WM_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY] = g_param_spec_object ("gesture-tracker", "gesture-tracker", "gesture-tracker", GALA_TYPE_GESTURE_TRACKER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_OPENED_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY] = g_param_spec_boolean ("opened", "opened", "opened", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2674 "WindowSwitcher.c"
}

static void
gala_window_switcher_instance_init (GalaWindowSwitcher * self,
                                    gpointer klass)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv = gala_window_switcher_get_instance_private (self);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_opened = FALSE;
#line 24 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = FALSE;
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = NULL;
#line 32 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = NULL;
#line 51 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = 1.0f;
#line 2693 "WindowSwitcher.c"
}

static void
gala_window_switcher_finalize (GObject * obj)
{
	GalaWindowSwitcher * self;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_wm);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_gesture_tracker);
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 27 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 28 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 29 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 30 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->shadow_effect);
#line 32 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (gala_window_switcher_parent_class)->finalize (obj);
#line 2720 "WindowSwitcher.c"
}

static GType
gala_window_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowSwitcher), 0, (GInstanceInitFunc) gala_window_switcher_instance_init, NULL };
	GType gala_window_switcher_type_id;
	gala_window_switcher_type_id = g_type_register_static (GALA_TYPE_CANVAS_ACTOR, "GalaWindowSwitcher", &g_define_type_info, 0);
	GalaWindowSwitcher_private_offset = g_type_add_instance_private (gala_window_switcher_type_id, sizeof (GalaWindowSwitcherPrivate));
	return gala_window_switcher_type_id;
}

GType
gala_window_switcher_get_type (void)
{
	static volatile gsize gala_window_switcher_type_id__once = 0;
	if (g_once_init_enter (&gala_window_switcher_type_id__once)) {
		GType gala_window_switcher_type_id;
		gala_window_switcher_type_id = gala_window_switcher_get_type_once ();
		g_once_init_leave (&gala_window_switcher_type_id__once, gala_window_switcher_type_id);
	}
	return gala_window_switcher_type_id__once;
}

static void
_vala_gala_window_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_wm (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_gesture_tracker (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_boolean (value, gala_window_switcher_get_opened (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2773 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2779 "WindowSwitcher.c"
	}
}

static void
_vala_gala_window_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_wm (self, g_value_get_object (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_gesture_tracker (self, g_value_get_object (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_opened (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2811 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2817 "WindowSwitcher.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 2832 "WindowSwitcher.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 2836 "WindowSwitcher.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 2840 "WindowSwitcher.c"
}

